#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Actor.h"
#include "BaseHusk.generated.h"

class USceneComponent;
class UDBDSkeletalMeshComponentBudgeted;
class UCustomizedSkeletalMesh;
class USkeletalMeshComponent;

UCLASS(Blueprintable)
class DBDGAMEPLAY_API ABaseHusk : public AActor
{
	GENERATED_BODY()

protected:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _shouldLoadOnServer;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	USceneComponent* _rootComponent;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UDBDSkeletalMeshComponentBudgeted* _huskMesh;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Instanced)
	UCustomizedSkeletalMesh* _huskCustomizedSkeletalMesh;

	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	bool _shouldDeactivateVFX;

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	bool _updateWeaponAccessories;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	bool _shouldWeaponBeVisible;

protected:
	UFUNCTION(BlueprintCallable)
	void SetScalarParameterOnAllChildrenMeshes(FName parameterName, float value, USkeletalMeshComponent* mesh);

public:
	UFUNCTION(BlueprintCallable)
	void SetHuskVisibility(bool visible);

	UFUNCTION(BlueprintCallable)
	void InitializeHusk(UCustomizedSkeletalMesh* customizedSkeletalMeshToCopy, USkeletalMeshComponent* skeletalMeshToCopy, int32 characterIdOverride);

	UFUNCTION(BlueprintPure)
	USkeletalMeshComponent* GetMesh() const;

	UFUNCTION(BlueprintPure)
	UCustomizedSkeletalMesh* GetCopiedCustomizedSkeletalMesh() const;

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent, BlueprintCosmetic)
	void Cosmetic_InitializeSkeletalMesh(USkeletalMeshComponent* mesh);

public:
	ABaseHusk();
};

FORCEINLINE uint32 GetTypeHash(const ABaseHusk) { return 0; }
